\class {field}
\security {1}
\name {HMML_form}
\script {
	switch (arg[0]) {
	case "D":
		tagPtr = STG_tagPtr("FORM");
		if (tagPtr) {
			i = STG_attr(tagPtr, "BGColor");
			if (i) set("BGColor", i);
			i = STG_attr(tagPtr, "FGColor");
			if (i) set("FGColor", i);
			i = STG_attr(tagPtr, "BDColor");
			if (i) set("BDColor", i);
		}
		h = SGMLBuildDoc_span();
		w = get("width");

		new = send("HMML_form.op", "clone", self());
		hh = send(new, "make", self(), w - 4, h);

		objectListAppend_children(new);

		set("height", h + hh);

		return h + hh;
	break;
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 */
		style = SGMLGetStyle("HMML", "SECTION");
		vspan = style[0];
		set("x", style[2]);
		set("y", arg[1] + vspan);
		set("width", arg[2] - x() - style[3]);
		n = countChildren();
		if (n) {
			xx = width() - 4;
			for (i = 0; i < n; i++) {
				vspan = vspan 
					+ send(nthChild(i), 'R', vspan, xx);
			}
		}
		set("height", vspan);
		vspan += style[1];
		return vspan;
	break;
	case 'r':
		style = SGMLGetStyle("HMML", "SECTION");
		vspan = style[0];
		n = countChildren();
		if (n) {
			xx = width();
			for (i = 0; i < n; i++) {
				vspan = vspan 
					+ send(nthChild(i), 'R', vspan, xx);
			}
		}
		set("height", vspan);
		vspan += style[1];
		return vspan;
	break;
	case "heightP":
		return get("height");
	break;
	case "widthP":
		return get("width");
	break;
	case "AI":
	case "noBullet":
		return;
	break;
	case "AA":
		switch (arg[1]) {
		case "MAXWIDTH":
			set("maxWidth", arg[2]);
		break;
		case "MINWIDTH":
			set("minWidth", arg[2]);
		break;
		case "ID":
			id = arg[2];	/* NOT USED YET */
		break;
		case "ACTION":
			action = arg[2];
		break;
		}
		return;
	break;
	case "searchAnchor":
		if (get("content2") == arg[1]) return self();
		n = countChildren();
		if (n > 0) {
			for (i = 0; i < n; i++) {
				anchor = send(nthChild(i), 
						"searchAnchor", arg[1]);
				if (anchor != "") return anchor;
			}
		}
		return "";
	break;
	case "gotoAnchor":
		if (get("content2") == arg[1]) return y();
		n = countChildren();
		if (n > 0) {
			for (i = 0; i < n; i++) {
				offset = send(nthChild(i), 
						"gotoAnchor", arg[1]);
				if (offset > 0) return offset + y();
			}
		}
		return 0;
	break;
	case "regInputer":
		/* every input object within the form reports to the form,
		 * so that at submission time, the form can query the input
		 * objects for values.
		 */
		inputers[icount] = arg[1];
		val = send(inputers[icount], "value");
		icount = icount + 1;
		return icount - 1;
	break;
	case "accept":
		if (action != "") {
			if (findPattern(action, "mailto:") != -1) {
				/* EMail results
				 */
				url = subject = send(send(parent(),
							"findTop"),
							 "query_docURL");
				subject = url;

				address = nthChar(action, 7, 999);
				content = concat("Form URL : ", url, "\n\n",
						 "Action   : ", action, "\n");

				for (i = 0; i < icount; i++) {
					content = concat(mh, "\n", content, 
						send(inputers[i], "value"),
						"\n");
				}
				tmpFile = makeTempFile();
				saveFile(tmpFile, content);
				cmd = concat("mail -s \"", subject,
					 "\" ", address, " < ", tmpFile);

				print("CMD >>", cmd, "<<\n");
				print("content=>>", content, "<<\n");

/*				system(cmd);*/

				system(concat("rm ", tmpFile));
			} else {
				/* Compress results into one-liner
				 */
				content = concat(action, "?");
				for (i = 0; i < icount; i++) {
					content = concat(content, 
						send(inputers[i], "value"),
						";");
				}
				print("F2.b content=>>", content, "<<\n");

				send(send(parent(), "findTop"), 
					"follow_href", content);
			}
		}
		return;
	break;
	case "findTop":
		return send(parent(), "findTop");
	break;
	case "findForm":
		return self();
	break;
	case "reportMailHeader":
		mh = arg[1];
		return;
	break;
	case "radioReg":
		/* arg[1]	name of radio group
		 * arg[2]	radio (input) object to be added to group
		 */
		radioID[radioi] = arg[1];
		radioObj[radioi] = arg[2];
		radioi++;
		return;
	break;
	case "radioOnReq":
		/* arg[1]	radio group index
		 * arg[2]	the radio (input) object to be turned ON
		 */
		radioGroupName = arg[1];
		for (i = 0; i < radioi; i++)
			if (radioID[i] == radioGroupName)
				send(radioObj[i], "radioOff");
		send(arg[2], "radioOn");
		return;
	break;
	}
	usual();
}
\BGColor {LemonChiffon1}
\BDColor {black}
\
\class {hpane}
\security {1}
\name {HMML_form.op}
\children {HMML_form.op.accept}
\script {
	switch (arg[0]) {
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 */
		set("y", arg[1] + 2);
		set("width", arg[2]);
		config();
		return get("height") + 4;
	break;
	case "make":
		/* arg[1]	parent
		 * arg[2]	width 
		 * arg[3]	y
		 */
		tagPtr = STG_tagPtr("FORM");
		if (tagPtr) {
			i = STG_attr(tagPtr, "BGColor");
			if (i) set("BGColor", i); 
			i = STG_attr(tagPtr, "BDColor");
			if (i) set("BDColor", i); 
			i = STG_attr(tagPtr, "FGColor");
			if (i) set("FGColor", i);
		}
		set("parent", arg[1]);
		set("width", arg[2]);
		set("y", arg[3] + 2);
		config();
		return get("height") + 4;
	break;
	case "clone":
		return clone(arg[1]);
	break;
	case "accept":
	case "cancel":
		return send(parent(), arg[0]);
	break;
	}
	usual();
}
\paneConfig {eastToWest}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\height {28}
\maxHeight {28}
\
\class {txtButton}
\security {1}
\parent {HMML_form.op}
\name {HMML_form.op.accept}
\label {Submit Form}
\gapV {3}
\gapH {4}
\x {3}
\y {3}
\width {150}
\height {28}
\font {normal}
\BGColor {grey45}
\BDColor {white}
\FGColor {green}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send(parent(), "accept");
	break;
	}
	usual();
}
\maxWidth {150}
\
